--hey! quit sneaking around in here!

SIMPLER_ANIMAL_SETUP("peppinobutcool", "WAIT", "ROLL", "SPNG", "RIDE", "EDGE", "FALL", "SPDA", "DASH", "JOGG", "CAZY", "LAND", "DVBM", "SKDD", "DRLF", "DRRF", "TAUN",
"SJPR", "SJGO", "SJCS", "SJCA", "GRAA", "GRAB", "GRAC", "GRBI", "GRBF", "GRBW", "PUNA", "PUNB", "PUNC", "PUND", "PUNE", "PUNF", "UPCE", "UPCB", "SWIM", "ASPN", "BSPN")-- Initiate character and custom Sprite2s.
SIMPLER_ANIMAL_SETUP("thenoisebutcool", "WAIT", "ROLL", "SPNG", "RIDE", "EDGE", "FALL", "SPDA", "DASH", "JOGG", "CAZY", "LAND", "DVBM", "SKDD", "DRLF", "DRRF", "TAUN",
"SJPR", "SJGO", "SJCS", "SJCA", "GRAA", "GRAB", "GRAC", "GRBI", "GRBF", "GRBW", "PUNA", "PUNB", "PUNC", "PUND", "PUNE", "PUNF", "UPCE", "UPCB", "SWIM", "ASPN", "BSPN")

freeslot("sfx_mach1", "sfx_mach2", "sfx_mach3", "sfx_mach4", "sfx_taunt", "MT_TAUNTEFFECTTHINGY", "MT_WALLCHECKER", "S_TAUNTBUBBBLE", "S_PIZZAFACE", "SPR_PIZF", "SPR_TANT", "sfx_upcut")

CV_RegisterVar({name = "PT_Jump",
				description = "Allows Peppino or The Noise to jump",
				defaultvalue = "On",
				flags = CV_NETVAR,
				PossibleValue = CV_OnOff})
CV_RegisterVar({name = "PT_Superjump",
				description = "Allows Peppino or The Noise to superjump",
				defaultvalue = "On",
				flags = CV_NETVAR,
				PossibleValue = CV_OnOff})
CV_RegisterVar({name = "PT_Taunt",
				description = "Allows Peppino or The Noise to taunt",
				defaultvalue = "On",
				flags = CV_NETVAR,
				PossibleValue = CV_OnOff})
CV_RegisterVar({name = "PT_Grab",
				description = "Allows Peppino or The Noise to grab",
				defaultvalue = "On",
				flags = CV_NETVAR,
				PossibleValue = CV_OnOff})
CV_RegisterVar({name = "PT_Uppercut",
				description = "Allows Peppino or The Noise to uppercut",
				defaultvalue = "On",
				flags = CV_NETVAR,
				PossibleValue = CV_OnOff})
CV_RegisterVar({name = "PT_Wallbounce",
				description = "Allows The Noise to wallbounce",
				defaultvalue = "On",
				flags = CV_NETVAR,
				PossibleValue = CV_OnOff})
CV_RegisterVar({name = "PT_Wallspin",
				description = "Allows The Noise to wallspin after a wallbounce",
				defaultvalue = "On",
				flags = CV_NETVAR,
				PossibleValue = CV_OnOff})
CV_RegisterVar({name = "PT_NoiseCrusher",
				description = "Allows The Noise to use his Noise Crusher",
				defaultvalue = "On",
				flags = CV_NETVAR,
				PossibleValue = CV_OnOff})

mobjinfo[MT_TAUNTEFFECTTHINGY] = {
	doomednum = -1,
	spawnstate = S_TAUNTBUBBBLE,
	flags = MF_SCENERY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_NOBLOCKMAP
}
mobjinfo[MT_WALLCHECKER] = {
	doomednum = -1,
	spawnstate = S_TAUNTBUBBBLE,
	flags = MF_SCENERY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_NOBLOCKMAP
}
states[S_TAUNTBUBBBLE] = {
	sprite = SPR_TANT,
	frame = FF_ANIMATE,
	tics = 18,
	var1 = 8,
	var2 = 2,
	nextstate = S_INVISIBLE,
}
states[S_PIZZAFACE] = {
	sprite = SPR_PIZF,
	frame = FF_ANIMATE,
	tics = -1,
	var1 = 15,
	var2 = 2,
	nextstate = S_PIZZAFACE,
}

addHook("PlayerSpawn", function(player) 
    if player.mo.skin == "peppinobutcool" or player.mo.skin == "thenoisebutcool" then
        player.therealtaunttimer = 20
        player.therealsuperjumpprepgoingup = 20
        player.tauntcooldown = 12
        player.sjumpcanceltimer = 20
        player.throwcooldown = 10
        player.grabbingtimer = 40
        player.grabcooldown = 40
        player.hittimer = 10
        player.uppercutanimtimer = 0
        player.escapevalue = 0
		player.noiseairspintimer = 5
		player.noisecrushertimer = 8
		player.doublejumptimer = 10
		player.wallsticktimer = 20

        -- Movement & Momentum
        player.prevmomx = 0
        player.prevmomy = 0
        player.prevmomz = 0
		player.wallclimbspeed = 0
        player.dx = 0
        player.dy = 0
        player.thezvalue = 15 * player.mo.scale

        -- States
        player.istaunting = false
        player.victimgotgrabbed = false
        player.issuperjumpprepping = false
        player.issuperjumping = false
        player.issuperjumpcancel = false
        player.dothatanimation = false
        player.ispunching = false
        player.ispunchinganim = false
        player.isgrabbing = false
        player.isjumping = false
        player.isuppercutting = false
        player.aircontrol = false
		player.climbing = false
		player.wasclimbing = false

        -- Permissions
        player.canyousuperjump = true
        player.canyoutaunt = true
        player.canyougrab = true
        player.canyoujump = true
        player.canyouuppercut = true
		player.canyouwallrun = true

        -- Randomized Values
        player.thetaunt = P_RandomRange(1, 10)
        player.thepunch = P_RandomRange(1, 5)

        -- Grabbing Mechanics
        player.grabspeedy = 0
        player.tingus = 0
        player.pingus = 0
        player.victimgotgrabbed = false
        player.grabbedvictim = nil
        player.grabber = nil
		player.setthethingstotrue = false
        -- Player Direction
        player.playerdirection = 0
        player.xinfrontoftheplayer = 0
        player.yinfrontoftheplayer = 0
		
        return
    end
end)

local helpers = _G["SIMPLER_ANIMAL_HELPERS"]

function SIMPLER_ANIMAL_HOOKS.peppinobutcool_hook(mobj)
	if helpers.getSkin(mobj) == "peppinobutcool" then
		local player = helpers.getPlayer(mobj)
		local machtwospeed = (K_GetKartSpeed(player, false, true) * 10) / 20
		local machthreespeed = (K_GetKartSpeed(player, false, true) * 15) / 20
		local machfourspeed = (K_GetKartSpeed(player, false, true) * 30) / 20
		local speedthreshold = player.mo.scale / 8
		for i = 0, 108 do
			S_StopSoundByID(mobj, sfx_krta00 + i) -- Stop engine sounds.
		end
		player.tauntcooldown = $ - 1
		player.grabcooldown = $ - 1
		player.hittimer = $ - 1
		player.uppercutanimtimer = $ - 1
		if mobj.sprite2 == SPR2_GOAL then
			return
		elseif (mobj.sprite2 == SPR2_SPIN) then return "SPIN", A, A, B
		elseif (mobj.sprite2 == SPR2_DEAD) return "DEAD", A, A, C
		elseif mobj.sprite2 == SPR2_STIL then return "STIN", A, A, T
		elseif player.climbing then return "SWIM", A, I, I
		elseif player.spindash then return "ROLL", A, A, L
		elseif player.rideroid or player.pullup or player.dlzrocket then return "FALL", A, A, C
		elseif player.istaunting and player.thetaunt == 1 then return "TAUN", A, A, A
		elseif player.istaunting and player.thetaunt == 2 then return "TAUN", B, B, B
		elseif player.istaunting and player.thetaunt == 3 then return "TAUN", C, C, C
		elseif player.istaunting and player.thetaunt == 4 then return "TAUN", D, D, D --This is so ass, there are better ways to do this
		elseif player.istaunting and player.thetaunt == 5 then return "TAUN", E, E, E
		elseif player.istaunting and player.thetaunt == 6 then return "TAUN", F, F, F
		elseif player.istaunting and player.thetaunt == 7 then return "TAUN", G, G, G
		elseif player.istaunting and player.thetaunt == 8 then return "TAUN", H, H, H
		elseif player.istaunting and player.thetaunt == 9 then return "TAUN", I, I, I
		elseif player.istaunting and player.thetaunt == 10 then return "TAUN", J, J, J
		elseif player.istaunting and player.thetaunt == 11 then return "TAUN", K, K, K
		elseif player.istaunting and player.thetaunt == 12 then return "TAUN", L, L, L
		elseif player.uppercutanimtimer >= 0 and player.isuppercutting then return "UPCE", A, U, U
		elseif player.uppercutanimtimer < 0 and player.isuppercutting then return "UPCB", A, A, A
		elseif player.ispunchinganim and player.thepunch == 1 then 
			helpers.SquaredSlow(mobj, -1) 
			return "PUNA", A, A, K
		elseif player.ispunchinganim and player.thepunch == 2 then 
			helpers.SquaredSlow(mobj, -1) 
			return "PUNB", A, A, K
		elseif player.ispunchinganim and player.thepunch == 3 then 
			helpers.SquaredSlow(mobj, -1) 
			return "PUNC", A, A, K
		elseif player.ispunchinganim and player.thepunch == 4 then 
			helpers.SquaredSlow(mobj, -1) 
			return "PUND", A, A, K
		elseif player.ispunchinganim and player.thepunch == 5 then 
			helpers.SquaredSlow(mobj, -1) 
			return "PUNE", A, A, K
		elseif player.ispunchinganim and player.thepunch == 6 then 
			helpers.SquaredSlow(mobj, -1) 
			return "PUNF", A, A, K
		elseif player.issuperjumpprepping then return "SJPR", A, S, S
		elseif player.issuperjumping or player.pingus == 1 then return "SJGO", A, A, H
		elseif player.issuperjumpcancel then return "SJCS", A, X, X
		elseif player.isgrabbing and player.grabbingtimer > 38 then return "GRAA", A, B, B
		elseif player.isgrabbing and player.grabbingtimer < 38 and player.grabbingtimer > 3 then return "GRAB", B, H, H
		elseif player.isgrabbing and player.grabbingtimer < 3 then return "GRAC", A, C, C
		elseif player.dothatanimation and helpers.isAirborne(mobj) then return "SJCA", A, A, D
		elseif player.victimgotgrabbed and helpers.isAirborne(mobj) then
			helpers.SquaredSlow(mobj, -1)
			return "GRBF", A, A, C
		elseif player.victimgotgrabbed and helpers.isMovingForward(mobj) then
			helpers.SquaredSlow(mobj, -1)
			return "GRBW", A, A, J
		elseif player.victimgotgrabbed then
			helpers.SquaredSlow(mobj, -1)
			return "GRBI", A, A, F
		elseif player.respawn.timer then
			helpers.SquaredSlow(mobj, -1)
			return "FALL", A, A, C
		elseif helpers.isTricking(mobj) and player.fastfall then
			return "DVBM", A, A, C
		elseif helpers.isTricking(mobj) then
			helpers.SquaredSlow(mobj, -1)
			return "FALL", A, A, C
		elseif (player.cmd.buttons & BT_BRAKE) and helpers.isMovingForward(mobj) and not helpers.isAirborne(mobj) then
			helpers.SquaredSlow(mobj, -1)
			return "SKDD", A, A, C
		elseif player.fastfall and ((player.speed >= machthreespeed) and (player.speed >= (player.lastspeed - speedthreshold))) then
			helpers.SquaredSlow(mobj, -1)
			return "LAND", A, A, C
		elseif player.fastfall then
			return "DVBM", A, A, H
		elseif (mobj.sprite2 == SPR2_DRLN or mobj.sprite2 == SPR2_DRRN) and helpers.isAirborne(mobj) then -- Slowable drift.
			helpers.SquaredSlow(mobj, -1)
			return "DRLF", A, A, C
		elseif (mobj.sprite2 == SPR2_DRLN or mobj.sprite2 == SPR2_DRRN) then -- Slowable drift.
			helpers.SquaredSlow(mobj, -1)
			return "DRLN", E, M, M
		elseif helpers.isAirborne(mobj) then
			helpers.SquaredSlow(mobj, -1)
			return "FALL", A, A, C
		elseif ((player.speed >= machfourspeed) and (player.speed >= (player.lastspeed - speedthreshold))) then
			helpers.SquaredSlow(mobj, -1)
			return "CAZY", A, A, H
		elseif ((player.speed >= machthreespeed) and (player.speed >= (player.lastspeed - speedthreshold))) then
			helpers.SquaredSlow(mobj, -1)
			return "FSTN", A, A, C
		elseif ((player.speed >= machtwospeed) and (player.speed >= (player.lastspeed - speedthreshold))) then
			helpers.SquaredSlow(mobj, -1)
			return "JOGG", A, A, H
		elseif mobj.sprite2 == SPR2_SLWN then
			if helpers.isMovingForward(mobj) then
				helpers.SquaredSlow(mobj, -1)
				return "SLWN", A, A, L
			else -- Moving sideways/backwards.
				if helpers.isMovingBackward(mobj) then
					helpers.SquaredSlow(mobj, 1)
					return "SLWN", L, L, A
				end
			end
		end
	end
end

function SIMPLER_ANIMAL_HOOKS.thenoisebutcool_hook(mobj)
	if helpers.getSkin(mobj) == "thenoisebutcool" then
		local player = helpers.getPlayer(mobj)
		local machtwospeed = (K_GetKartSpeed(player, false, true) * 10) / 20
		local machthreespeed = (K_GetKartSpeed(player, false, true) * 15) / 20
		local machfourspeed = (K_GetKartSpeed(player, false, true) * 30) / 20
		local speedthreshold = player.mo.scale / 8
		for i = 0, 108 do
			S_StopSoundByID(mobj, sfx_krta00 + i) -- Stop engine sounds.
		end
		player.tauntcooldown = $ - 1
		player.grabcooldown = $ - 1
		player.hittimer = $ - 1
		player.noiseairspintimer = $ - 1
		player.uppercutanimtimer = $ - 1
		player.noisecrushertimer = $ - 1
		player.doublejumptimer = $ - 1
		if mobj.sprite2 == SPR2_GOAL then
			return
		elseif (mobj.sprite2 == SPR2_SPIN) then return "SPIN", A, A, B
		elseif (mobj.sprite2 == SPR2_DEAD) return "DEAD", A, A, C
		elseif mobj.sprite2 == SPR2_STIL then return "STIN", A, A, Q
		elseif player.spindash then return "SLWN", A, A, H
		elseif player.rideroid or player.pullup or player.dlzrocket then return "FALL", A, A, C
		elseif player.istaunting and player.thetaunt == 1 then return "TAUN", A, A, A
		elseif player.istaunting and player.thetaunt == 2 then return "TAUN", B, B, B
		elseif player.istaunting and player.thetaunt == 3 then return "TAUN", C, C, C
		elseif player.istaunting and player.thetaunt == 4 then return "TAUN", D, D, D --This is so ass, there are better ways to do this
		elseif player.istaunting and player.thetaunt == 5 then return "TAUN", E, E, E
		elseif player.istaunting and player.thetaunt == 6 then return "TAUN", F, F, F
		elseif player.istaunting and player.thetaunt == 7 then return "TAUN", G, G, G
		elseif player.istaunting and player.thetaunt == 8 then return "TAUN", H, H, H
		elseif player.istaunting and player.thetaunt == 9 then return "TAUN", I, I, I
		elseif player.istaunting and player.thetaunt == 10 then return "TAUN", J, J, J
		elseif player.uppercutanimtimer >= 0 and player.isuppercutting then return "UPCE", A, U, U
		elseif player.uppercutanimtimer < 0 and player.isuppercutting then return "UPCE", U, U, U
		elseif player.isnoisecrusher and player.noisecrushertimer > 0 then return "SJCS", A, H, H
		elseif player.isnoisecrusher and player.noisecrushertimer <= 0 then return "SJCA", A, A, C
		elseif player.noiseairspin and player.noiseairspintimer >= 0 then return "BSPN", A, E, E
		elseif player.noiseairspin and player.noiseairspintimer < 0 then return "ASPN", A, G, G
		elseif player.noisewallbounce then return "SWIM", A, J, J
		elseif player.ispunchinganim and player.thepunch == 1 then 
			helpers.SquaredSlow(mobj, -1) 
			return "PUNA", A, A, K
		elseif player.ispunchinganim and player.thepunch == 2 then 
			helpers.SquaredSlow(mobj, -1) 
			return "PUNB", A, A, K
		elseif player.ispunchinganim and player.thepunch == 3 then 
			helpers.SquaredSlow(mobj, -1) 
			return "PUNC", A, A, K
		elseif player.ispunchinganim and player.thepunch == 4 then 
			helpers.SquaredSlow(mobj, -1) 
			return "PUND", A, A, K
		elseif player.ispunchinganim and player.thepunch == 5 then 
			helpers.SquaredSlow(mobj, -1) 
			return "PUNE", A, A, K
		elseif player.ispunchinganim and player.thepunch == 6 then 
			helpers.SquaredSlow(mobj, -1) 
			return "PUNF", A, A, K
		elseif player.issuperjumpprepping then return "SJPR", A, S, S
		elseif player.issuperjumping then return "SJGO", A, A, D
		elseif player.isgrabbing and player.grabbingtimer > 38 then return "GRAA", A, B, B
		elseif player.isgrabbing and player.grabbingtimer < 38 and player.grabbingtimer > 3 then return "GRAB", A, G, G
		elseif player.isgrabbing and player.grabbingtimer < 3 then return "GRAC", A, C, C
		elseif player.victimgotgrabbed and helpers.isAirborne(mobj) then
			helpers.SquaredSlow(mobj, -1)
			return "GRBF", A, A, C
		elseif player.victimgotgrabbed and helpers.isMovingForward(mobj) then
			helpers.SquaredSlow(mobj, -1)
			return "GRBW", A, A, J
		elseif player.victimgotgrabbed then
			helpers.SquaredSlow(mobj, -1)
			return "GRBI", A, A, H
		elseif player.respawn.timer then
			helpers.SquaredSlow(mobj, -1)
			return "FALL", A, A, C
		elseif helpers.isTricking(mobj) and player.fastfall then
			return "DVBM", A, A, C
		elseif helpers.isTricking(mobj) then
			helpers.SquaredSlow(mobj, -1)
			return "FALL", A, A, C
		elseif (player.cmd.buttons & BT_BRAKE) and helpers.isMovingForward(mobj) and not helpers.isAirborne(mobj) then
			helpers.SquaredSlow(mobj, -1)
			return "SKDD", A, A, C
		elseif player.fastfall and ((player.speed >= machthreespeed) and (player.speed >= (player.lastspeed - speedthreshold))) then
			helpers.SquaredSlow(mobj, -1)
			return "LAND", A, A, C
		elseif player.fastfall then
			return "LAND", A, A, C
		elseif (mobj.sprite2 == SPR2_DRLN or mobj.sprite2 == SPR2_DRRN) and helpers.isAirborne(mobj) then -- Slowable drift.
			helpers.SquaredSlow(mobj, -1)
			return "DRLN", A, A, D
		elseif (mobj.sprite2 == SPR2_DRLN or mobj.sprite2 == SPR2_DRRN) then -- Slowable drift.
			helpers.SquaredSlow(mobj, -1)
			return "DRLN", A, A, D
		elseif helpers.isAirborne(mobj) then return "FALL", A, A, C
		elseif ((player.speed >= machfourspeed) and (player.speed >= (player.lastspeed - speedthreshold))) then
			helpers.SquaredSlow(mobj, -1)
			return "CAZY", A, A, C
		elseif ((player.speed >= machthreespeed) and (player.speed >= (player.lastspeed - speedthreshold))) then
			helpers.SquaredSlow(mobj, -1)
			return "FSTN", A, A, C
		elseif ((player.speed >= machtwospeed) and (player.speed >= (player.lastspeed - speedthreshold))) then
			helpers.SquaredSlow(mobj, -1)
			return "JOGG", A, A, F
		elseif mobj.sprite2 == SPR2_SLWN then
			if helpers.isMovingForward(mobj) then
				helpers.SquaredSlow(mobj, -1)
				return "SLWN", A, A, H
			else -- Moving sideways/backwards.
				if helpers.isMovingBackward(mobj) then
					helpers.SquaredSlow(mobj, 1)
					return "SLWN", H, H, A
				end
			end
		end
	end
end

addHook("PlayerThink", function(player) -- the jump
	if player.mo == nil then return end
	if player.mo.skin == "peppinobutcool" or player.mo.skin == "thenoisebutcool" then
		if player.spinouttimer > 0 or player.tumblebounces > 0 or player.respawn.timer then
        player.istaunting = false
        player.victimgotgrabbed = false
        player.issuperjumpprepping = false
        player.issuperjumping = false
        player.issuperjumpcancel = false
        player.dothatanimation = false
        player.ispunching = false
        player.ispunchinganim = false
        player.isgrabbing = false
        player.isjumping = false
        player.isuppercutting = false
        player.aircontrol = false
		player.noisewallbounce = false
		player.noiseairspin = false
		player.noisecrusher = false
		player.climbing = false
		player.wasclimbing = false
		player.isstickflighting = false
		player.isstickflightspin = false
		player.isstickflightcancel = false
		player.stickairswim = false
		player.stickairspin = false
		player.doublejumping = false
		player.isstickingtowall = false
		player.setthethingstotrue = false
        player.canyousuperjump = false
        player.canyoutaunt = false
        player.canyougrab = false
        player.canyoujump = false
        player.canyouuppercut = false
		player.canyoudothespin = false
		player.canyouwallrun = false
		player.canyoudoublejump = false
		end
		if player.spinouttimer <= 0 and player.tumblebounces <= 0 and not player.respawn.timer and not player.setthethingstotrue then
			player.setthethingstotrue = true
			player.canyousuperjump = true
			player.canyoutaunt = true
			player.canyougrab = true
			player.canyoujump = true
			player.canyouuppercut = true
			player.canyoudothespin = true
			player.canyouwallrun = true
			player.canyoudoublejump = true
		end
	end
end)


addHook("PlayerThink", function(player) -- the jump
	if player.mo == nil then return end
	if player.mo.skin == "peppinobutcool" or player.mo.skin == "thenoisebutcool" then
		if (player.cmd.buttons & BT_LUAA) and not (player.cmd.buttons & BT_DRIFT) and P_IsObjectOnGround(player.mo) and CV_FindVar("PT_Jump").value == 1 then -- this code makes you jump
			if (player.mo.eflags & MFE_VERTICALFLIP) then
				player.mo.momz = -16*player.mo.scale
			else
				player.mo.momz = 16*player.mo.scale
			end
		end
	end
end)

addHook("PlayerThink", function(player) -- the wallbounce
	if player.mo == nil then return end
	if player.mo.skin == "thenoisebutcool" then
		if player.spinouttimer <= 0 and player.tumblebounces <= 0 and not player.respawn.timer and player.mo.eflags & MFE_JUSTBOUNCEDWALL and not P_IsObjectOnGround(player.mo) and not player.isuppercutting and not player.isnoisecrusher and CV_FindVar("PT_Wallbounce").value == 1 and not (player.victimgotgrabbed and player.grabbedvictim and player.grabber and player.grabber.valid and player.grabbedvictim.valid) then -- this code makes you jump
			player.noisewallbounce = true
			if (player.mo.eflags & MFE_VERTICALFLIP) then
				player.mo.momz = -24*player.mo.scale
			else
				player.mo.momz = 24*player.mo.scale
			end
			player.canyougrab = false
			player.canyoudothespin = true
			player.noiseairspin = false
			player.isgrabbing = false
		end
		if P_IsObjectOnGround(player.mo) then --this puts you back to normal and resets the realtaunt timer
			player.canyoujump = true
			player.canyougrab = true
			player.noisewallbounce = false
			player.canyoudothespin = false
			player.noiseairspintimer = 5
		end
	end
end)

addHook("PlayerThink", function(player) -- the air spin
    if player.mo == nil then return end
    if player.mo.skin == "thenoisebutcool" then
        player.playerdirection = player.mo.angle
		if (player.cmd.buttons & BT_LUAB) and player.canyoudothespin and player.noiseairspintimer < 0 and not player.isuppercutting and CV_FindVar("PT_Wallspin").value == 1 then -- this code makes you jump
			player.noiseairspintimer = 5
			player.noiseairspin = true
			player.canyougrab = false
			player.canyoudothespin = false
			player.canyoutaunt = true
		end
		if player.noiseairspin then
			player.isnoisecrusher = false
			player.mo.momx = FixedMul(cos(player.playerdirection), 32*player.mo.scale)
			player.mo.momy = FixedMul(sin(player.playerdirection), 32*player.mo.scale)
		end
		if P_IsObjectOnGround(player.mo) then --this puts you back to normal and resets the realtaunt timer
			player.canyoujump = true
			player.noiseairspin = false
			player.noisewallbounce = false
			player.canyoudothespin = false
		end
		if player.isuppercutting then --for some damn reason
			player.noiseairspin = false
		end
	end
end)

addHook("PlayerThink", function(player) -- uppercutting
	if player.mo == nil then return end
	if player.mo.skin == "peppinobutcool" or player.mo.skin == "thenoisebutcool" then
		if (player.cmd.buttons & BT_LUAB) and player.throwdir == 1 and not (player.cmd.buttons & BT_DRIFT) and not player.ispunchinganim and player.canyouuppercut and CV_FindVar("PT_Uppercut").value == 1 then -- this code makes you jump
			player.canyouuppercut = false
			if player.mo.skin == "thenoisebutcool" then
				if (player.mo.eflags & MFE_VERTICALFLIP) then
					player.mo.momz = -32*player.mo.scale
				else
					player.mo.momz = 32*player.mo.scale
				end
			else
				if (player.mo.eflags & MFE_VERTICALFLIP) then
					player.mo.momz = -24*player.mo.scale
				else
					player.mo.momz = 24*player.mo.scale
				end
			end
			player.uppercutanimtimer = 16
			player.isuppercutting = true
			player.canyoutaunt = false
		end
		if P_IsObjectOnGround(player.mo) then --this puts you back to normal and resets the realtaunt timer
			player.canyouuppercut = true
			player.pingus = 0
			player.isuppercutting = false
		end
	end
end)

addHook("PlayerThink", function(player) -- the taunt
	if player.mo == nil then return end
	if player.mo.skin == "peppinobutcool" or player.mo.skin == "thenoisebutcool" then
		if (player.cmd.buttons & BT_LUAC) and player.tauntcooldown < 0 and player.canyoutaunt and not player.isuppercutting and CV_FindVar("PT_Taunt").value == 1 and not (player.victimgotgrabbed and player.grabbedvictim and player.grabber and player.grabber.valid and player.grabbedvictim.valid) then -- i guess this randomizes the frames and stores your speed.
			if player.mo.skin == "thenoisebutcool" then
				player.thetaunt = P_RandomRange(1, 10)
			else
				player.thetaunt = P_RandomRange(1, 12)
			end
			P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_TAUNTEFFECTTHINGY)
			player.istaunting = true
			S_StartSound(player.mo, sfx_taunt)
			player.prevmomx = player.mo.momx
			player.prevmomy = player.mo.momy
			player.prevmomz = player.mo.momz
			player.canyougrab = false
			player.canyousuperjump = false
			player.canyoujump = false
			player.canyouuppercut = false
		end
		if player.istaunting and not player.respawn.timer then -- the code checks if youre taunting or not i suppose. it also freezes you and makes you invincible
			player.istaunting = true
			player.tauntcooldown = 20
			player.mo.momx = 0
			player.mo.momy = 0
			player.mo.momz = 0
			player.spinouttype = KSPIN_IFRAMES
			player.flashing = 2
			player.therealtaunttimer = player.therealtaunttimer - 1
		end
		if player.therealtaunttimer <= 0 then --this puts you back to normal and resets the realtaunt timer
			player.istaunting = false
			player.mo.momx = player.prevmomx
			player.mo.momy = player.prevmomy
			player.mo.momz = player.prevmomz
			player.tauntcooldown = player.tauntcooldown - 1
			player.therealtaunttimer = 20
			player.canyougrab = true
			player.canyousuperjump = true
			player.canyouuppercut = true
		end
	end
end)

addHook("PlayerThink", function(player) -- the superjump
	if player.mo == nil then return end
	player.playerdirection = player.mo.angle
	if player.mo.skin == "peppinobutcool" or player.mo.skin == "thenoisebutcool" then
		if (player.cmd.buttons & BT_LUAA) and not (player.cmd.buttons & BT_DRIFT) and player.throwdir == 1 and player.canyousuperjump and P_IsObjectOnGround(player.mo) and CV_FindVar("PT_Superjump").value == 1 then -- superjump start button
			player.issuperjumpprepping = true
			if player.mo.momx >= 0 then player.mo.momx = $ - 1 end
			if player.mo.momy >= 0 then player.mo.momy = $ - 1 end
			if player.mo.momz >= 0 then player.mo.momz = $ - 1 end
			player.sjumpcanceltimer = 20
			player.canyoutaunt = false
			player.canyougrab = false
			player.canyoujump = false
			player.canyouuppercut = false
		end
		if player.issuperjumpprepping and not player.respawn.timer then -- superjump pause
			player.issuperjumpprepping = true
			player.mo.momx = 0
			player.mo.momy = 0
			player.mo.momz = 0
			player.therealsuperjumpprepgoingup = $ - 1
		end
		if gametype == GT_BATTLE and player.therealsuperjumpprepgoingup <= 0 then
			player.issuperjumpprepping = false
			player.therealsuperjumpprepgoingup = 20
			player.pingus = 1
			player.mo.momx = 0
			player.mo.momy = 0
			if (player.mo.eflags & MFE_VERTICALFLIP) then
				player.mo.momz = -48*player.mo.scale
			else
				player.mo.momz = 48*player.mo.scale
			end
			player.issuperjumping = false
		end
		if player.therealsuperjumpprepgoingup <= 0 then --this part makes you go upwards
			player.issuperjumpprepping = false
			player.mo.momx = 0
			player.mo.momy = 0
			if (player.mo.eflags & MFE_VERTICALFLIP) then
				player.mo.momz = -32*player.mo.scale
			else
				player.mo.momz = 32*player.mo.scale
			end
			player.issuperjumping = true
		end
		if (player.cmd.buttons & BT_DRIFT) and player.issuperjumping and not player.issuperjumpcancel and player.mo.skin == "thenoisebutcool" then --superjump cancel start for noise
			player.issuperjumping = false
			player.therealsuperjumpprepgoingup = 20
			if (player.mo.eflags & MFE_VERTICALFLIP) then
				player.mo.momz = -8*player.mo.scale
			else
				player.mo.momz = 8*player.mo.scale
			end
			player.noiseairspintimer = 5
			player.noiseairspin = true
			player.canyougrab = false
			player.canyoudothespin = false
		end
		if (player.cmd.buttons & BT_DRIFT or player.cmd.buttons & BT_BRAKE) and player.issuperjumping and not player.issuperjumpcancel then --superjump cancel start start
			player.therealsuperjumpprepgoingup = 20
			player.issuperjumping = false
			player.mo.momx = 0
			player.mo.momy = 0
			player.mo.momz = 0
			player.issuperjumpcancel = true
		end
		if player.issuperjumpcancel then --superjump cancel start
			player.mo.momx = 0
			player.mo.momy = 0
			player.mo.momz = 0
			player.sjumpcanceltimer = $ - 1
		end
		if player.sjumpcanceltimer < 0 then --this is the superjump cancel fly off code
			player.dothatanimation = true
			player.mo.momx = FixedMul(cos(player.playerdirection), 80*player.mo.scale)
			player.mo.momy = FixedMul(sin(player.playerdirection), 80*player.mo.scale)
			player.mo.momz = FixedMul(sin(player.mo.angle), 2*player.mo.scale)
			player.issuperjumpcancel = false
			player.canyoujump = false
			player.sjumpcanceltimer = 20
			player.canyoutaunt = true
			player.aircontrol = true
		end
		if player.aircontrol and not player.istaunting then
			player.mo.momx = FixedMul(cos(player.playerdirection), 80*player.mo.scale)
			player.mo.momy = FixedMul(sin(player.playerdirection), 80*player.mo.scale)
		end
		if player.aircontrol and player.mo.eflags & MFE_JUSTBOUNCEDWALL then
			player.aircontrol = false
		end
		if player.dothatanimation and P_IsObjectOnGround(player.mo) then --this makes the player stop doing the superjump cancel animation when they touch the ground
			player.dothatanimation = false
			player.aircontrol = false
			player.canyougrab = true
			player.canyoutaunt = true
			player.canyouuppercut = true
			player.canyoujump = true
		end
	end
end)

addHook("PlayerThink", function(player) -- noise crusher
	if player.mo == nil then return end
	if player.mo.skin == "thenoisebutcool" then
		if (player.cmd.buttons & BT_LUAA) and not P_IsObjectOnGround(player.mo) and player.throwdir == 1 and not player.isnoisecrusher and not player.isuppercutting and not (player.victimgotgrabbed and player.grabbedvictim and player.grabber and player.grabber.valid and player.grabbedvictim.valid) and not player.isgrabbing and not player.issuperjumping and CV_FindVar("PT_NoiseCrusher").value == 1 then -- this code makes you jump
			player.isnoisecrusher = true
			player.noiseairspin = false
			player.noisecrushertimer = 8
			player.canyoudothespin = true
			if (player.mo.eflags & MFE_VERTICALFLIP) then
				player.mo.momz = -32*player.mo.scale
			else
				player.mo.momz = 32*player.mo.scale
			end
		end
		if P_IsObjectOnGround(player.mo) then --this puts you back to normal and resets the realtaunt timer
			player.isnoisecrusher = false
		end
	end
end)

addHook("PlayerThink", function(player) -- the hellish grab code
    if player.mo == nil then return end
    if player.mo.skin == "peppinobutcool" or player.mo.skin == "thenoisebutcool" then
        player.playerdirection = player.mo.angle
        if (player.cmd.buttons & BT_LUAB) and player.throwdir != 1 and player.canyougrab and player.grabcooldown < 0 and not player.isuppercutting and CV_FindVar("PT_Grab").value == 1 then
            player.isgrabbing = true
			player.canyousuperjump = false
			player.canyoutaunt = false
            player.tingus = true
            player.throwcooldown = 10
            player.canyougrab = false
			if (player.mo.eflags & MFE_VERTICALFLIP) then
				player.thezvalue = -60*player.mo.scale
			else
				player.thezvalue = 60*player.mo.scale
			end
			
        end
        if player.tingus then
            player.grabspeedx = FixedMul(cos(player.playerdirection), 24*player.mo.scale)
            player.grabspeedy = FixedMul(sin(player.playerdirection), 24*player.mo.scale)
        end
        if player.isgrabbing then
            player.grabbingtimer = $ - 1
            player.mo.momx = player.grabspeedx
            player.mo.momy = player.grabspeedy

            for mobj in mobjs.iterate() do
				if mobj.valid and mobj.type == MT_PLAYER and mobj ~= player.mo and P_AproxDistance(mobj.x - player.mo.x, mobj.y - player.mo.y) <= 100*player.mo.scale then
					player.victimgotgrabbed = true
					player.grabbedvictim = mobj
					player.grabber = player.mo
					player.grabbedvictim.momx = 0
					player.grabbedvictim.momy = 0
					player.grabbedvictim.momz = 0
					player.grabbedvictim.player.canyougrab = false
					player.grabbedvictim.player.canyoujump = false
					player.grabbedvictim.player.canyousuperjump = false
					player.grabbedvictim.player.canyoutaunt = false
					player.grabbedvictim.player.canyouuppercut = false
					break
				end
			end
        end
        if player.grabbingtimer <= 0 or (player.victimgotgrabbed and player.grabbedvictim and player.grabber and player.grabber.valid and player.grabbedvictim.valid) or player.mo.eflags & MFE_JUSTBOUNCEDWALL then
            player.isgrabbing = false
            player.tingus = false
            player.grabcooldown = 40
            player.grabbingtimer = 40
            player.canyougrab = true
			player.canyousuperjump = true
			player.canyoutaunt = true
        end
        if (player.victimgotgrabbed and player.grabbedvictim and player.grabber and player.grabber.valid and player.grabbedvictim.valid) then
            player.canyougrab = false
			player.canyousuperjump = false
			player.canyoutaunt = false
			player.canyoudothespin = false
            player.grabbedvictim.momx = 0
            player.grabbedvictim.momy = 0
            player.grabbedvictim.momz = 0
            P_SetOrigin(player.grabbedvictim, player.grabber.x + player.xinfrontoftheplayer, player.grabber.y + player.yinfrontoftheplayer, player.grabber.z + player.thezvalue)
            player.throwcooldown = $ - 1
            if (player.cmd.buttons & BT_LUAB) and player.throwcooldown <= 0 and not player.ispunching and player.throwdir != 1 then
				if (player.mo.eflags & MFE_VERTICALFLIP) then
					player.thezvalue = -10
				else
					player.thezvalue = 10
				end
				player.thepunch = P_RandomRange(1, 5)
				player.xinfrontoftheplayer = FixedMul(cos(player.grabber.angle), 80*player.mo.scale)
				player.yinfrontoftheplayer = FixedMul(sin(player.grabber.angle), 80*player.mo.scale)
                P_SetOrigin(player.grabbedvictim, player.grabber.x + player.xinfrontoftheplayer, player.grabber.y + player.yinfrontoftheplayer, player.grabber.z + player.thezvalue)
				player.ispunching = true
                player.hittimer = 40
                player.throwcooldown = 10
			elseif (player.cmd.buttons & BT_LUAB) and player.throwcooldown <= 0 and not player.ispunching and player.throwdir == 1 then
				player.thezvalue = 10
				player.thepunch = 6
				player.xinfrontoftheplayer = FixedMul(cos(player.grabber.angle), 80*player.mo.scale)
				player.yinfrontoftheplayer = FixedMul(sin(player.grabber.angle), 80*player.mo.scale)
                P_SetOrigin(player.grabbedvictim, player.grabber.x + player.xinfrontoftheplayer, player.grabber.y + player.yinfrontoftheplayer, player.grabber.z + player.thezvalue)
				player.ispunching = true
                player.hittimer = 40
                player.throwcooldown = 10
            end
			if (player.grabbedvictim.player.cmd.buttons & BT_ACCELERATE) and player.victimgotgrabbed then
				player.escapevalue = $ + 1
			end
            if player.hittimer > 0 and player.ispunching then
				player.grabber.momx = 0
				player.grabber.momy = 0
				player.grabber.momz = 0
				player.ispunchinganim = true
                if player.hittimer == 20 and player.thepunch <= 5 then
					player.grabbedvictim.player.canyougrab = true
					player.grabbedvictim.player.canyoujump = true
					player.grabbedvictim.player.canyousuperjump = true
					player.grabbedvictim.player.canyoutaunt = true
					player.grabbedvictim.player.canyouuppercut = true
                    P_DamageMobj(player.grabbedvictim, player.grabber, player.grabber, 1, DMG_NORMAL)
					player.grabbedvictim.momx = FixedMul(cos(player.grabber.angle), 32*player.mo.scale)
					player.grabbedvictim.momy = FixedMul(sin(player.grabber.angle), 32*player.mo.scale)
                    player.victimgotgrabbed = false
                    player.grabbedvictim = nil
                    player.grabber = nil
					player.xinfrontoftheplayer = 0
					player.yinfrontoftheplayer = 0
					player.escapevalue = 0
				elseif player.hittimer == 20 and player.thepunch == 6 then
					player.grabbedvictim.player.canyougrab = true
					player.grabbedvictim.player.canyoujump = true
					player.grabbedvictim.player.canyousuperjump = true
					player.grabbedvictim.player.canyoutaunt = true
					player.grabbedvictim.player.canyouuppercut = true
                    P_DamageMobj(player.grabbedvictim, player.grabber, player.grabber, 1, DMG_NORMAL)
					if (player.mo.eflags & MFE_VERTICALFLIP) then
						player.grabbedvictim.momz = -32 * player.mo.scale
					else
						player.grabbedvictim.momz = 32 * player.mo.scale
					end
                    player.victimgotgrabbed = false
                    player.grabbedvictim = nil
                    player.grabber = nil
					player.xinfrontoftheplayer = 0
					player.yinfrontoftheplayer = 0
					player.escapevalue = 0
                end
            end
            if player.spinouttimer > 0 or player.escapevalue == 40 then
				player.grabbedvictim.player.canyougrab = true
				player.grabbedvictim.player.canyoujump = true
				player.grabbedvictim.player.canyousuperjump = true
				player.grabbedvictim.player.canyoutaunt = true
				player.grabbedvictim.player.canyouuppercut = true
                player.grabbedvictim.momx = FixedMul(cos(player.grabbedvictim.angle), 64*player.mo.scale)
                player.grabbedvictim.momy = FixedMul(sin(player.grabbedvictim.angle), 64*player.mo.scale)
				if (player.mo.eflags & MFE_VERTICALFLIP) then
					player.grabbedvictim.momz = -16 * player.mo.scale
				else
					player.grabbedvictim.momz = 16 * player.mo.scale
				end
                player.grabcooldown = 40
                player.grabbingtimer = 0
                player.victimgotgrabbed = false
                player.grabbedvictim = nil
                player.grabber = nil
				player.canyougrab = true
				player.escapevalue = 0
            end
        else
            player.victimgotgrabbed = false
            player.grabbedvictim = nil
            player.grabber = nil
        end
    end
	if player.hittimer == 1 and player.ispunchinganim then
		player.ispunching = false
		player.ispunchinganim = false
		player.canyougrab = true
		player.canyousuperjump = true
		player.canyoutaunt = true
	end
end)

local spb_reskin = function(mo)
    if mo and mo.valid then
        if (mo.target and mo.target.skin == "peppinobutcool") or (mo.target and mo.target.skin == "thenoisebutcool") then
            if not mo.init then
                if mo.type == MT_SPB then
                    mo.state = S_PIZZAFACE
                end
                mo.init = true
            end
        end
    end
end

addHook("MobjThinker", spb_reskin, MT_SPB)